## bladerf-2025.10.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)
project(bladeRF CXX C)
# Indicate that this is a top-level build
set(BLADERF_TOP_LEVEL_BUILD ON)

#####################################################################
# Choose which major components to build
#####################################################################
option(ENABLE_HOST_BUILD
       "Build the bladeRF host components"
       ON
)

option(ENABLE_FX3_BUILD
       "Build the Cypress FX3 firmware component. Be sure to define FX3_SDK_PATH"
       OFF
)

#####################################################################
# Flag for development version vs tagged release
#####################################################################
option(TAGGED_RELEASE
       "Indicates that this is a tagged release.  Drops '-git' flag."
       OFF
)

if(TAGGED_RELEASE)
    set(VERSION_INFO_EXTRA "")
else()
    set(VERSION_INFO_EXTRA "git")
endif()

#####################################################################
# Build components
#####################################################################
if(ENABLE_HOST_BUILD)
    add_subdirectory(host)
else()
    message(STATUS "Skipping host component build")
endif()

if(ENABLE_FX3_BUILD)
    include(ExternalProject)
    ExternalProject_Add(fx3_firmware
        DOWNLOAD_COMMAND ""
        SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/fx3_firmware"
        CMAKE_ARGS "-DFX3_INSTALL_PATH=${FX3_INSTALL_PATH};-DCMAKE_TOOLCHAIN_FILE=${CMAKE_CURRENT_SOURCE_DIR}/fx3_firmware/cmake/fx3-toolchain.cmake"
        BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/fx3_firmware"
        PREFIX     "${CMAKE_CURRENT_BINARY_DIR}/fx3_firmware"
        INSTALL_COMMAND ""
        BUILD_ALWAYS true
    )
else()
    message(STATUS "Skipping FX3 firmware build")
endif()

=== fx3_firmware/CMakeLists.txt ===
################################################################################
# Build bladeRF FX3 Firmware
################################################################################
cmake_minimum_required(VERSION 3.5)
project(bladeRF_fw C)

################################################################################
# Project configuration
################################################################################

# All build output lands in this directory:
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_HELPERS_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/cmake/helpers)
set(CMAKE_HELPERS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/cmake/helpers)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message(STATUS
        "Build type not specified. Defaulting to: ${CMAKE_BUILD_TYPE}"
    )
endif()

set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Build type")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/../host/cmake/modules)

################################################################################
# Version configuration
################################################################################

# Update these definitions when updating the firmware version
set(VERSION_INFO_MAJOR 2)
set(VERSION_INFO_MINOR 6)
set(VERSION_INFO_PATCH 0)

if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")

# Generate firmware version header file
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/include/version.h
    @ONLY
)

################################################################################
# Configuration options
################################################################################

option(ENABLE_BLADERF_FIRMWARE
    "Build firmware for the bladeRF 1.0"
    ON
)

################################################################################
# Build Configuration
################################################################################

# Paths for input files
set(INCLUDE_DIRS
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_CURRENT_BINARY_DIR}/include"
    "${CMAKE_CURRENT_SOURCE_DIR}/../firmware_common"
    "${FX3_INCLUDE_DIR}")

set(SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src")

# Base filenames for output files
set(BLADERF_FW bladeRF_fw_v${VERSION_INFO_BASE})

# Common source files
set(SRC_BLADERF
    "${SRC_DIR}/bladeRF.c"
    "${SRC_DIR}/cyfxbladeRFusbdscr.c"
    "${SRC_DIR}/flash.c"
    "${SRC_DIR}/fpga.c"
    "${SRC_DIR}/gpif.c"
    "${SRC_DIR}/logger.c"
    "${SRC_DIR}/rf.c"
    "${SRC_DIR}/spi_flash_lib.c"
    "${FX3_FW_COMMON_DIR}/cyfx_gcc_startup.S"
    "${FX3_FW_COMMON_DIR}/cyfxtx.c"
    "${SRC_DIR}/bladeRF1.c"
    "${SRC_DIR}/bladeRF2.c"
)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "-O0 -g")
else()
    set(CMAKE_C_FLAGS "-O2")
endif()

set(CMAKE_C_FLAGS
    "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -DCYU3P_FX3=1 \
     -D__CYU3P_TX__=1 -mcpu=arm926ej-s -mthumb-interwork"
)

include_directories(${INCLUDE_DIRS})
enable_language(ASM)

set(CMAKE_EXE_LINKER_FLAGS
    "-Wl,--entry,CyU3PFirmwareEntry \
     -Wl,-T,\"${FX3_LINKER_FILE}\" \
     -Wl,-d -Wl,--gc-sections \
     -Wl,--no-wchar-size-warning"
)

################################################################################
# Build or find required host utililities
################################################################################

if(FX3_WINDOWS_HOST)
    set(ELF2IMG ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/elf2img.exe)

    # A prebuild-elf2img binary ships with the FX3 SDK.
    # Just copy it to our output directory for simplicity.
    add_custom_command(
        OUTPUT ${ELF2IMG}
        COMMAND ${CMAKE_COMMAND} -E copy ${FX3_ELF2IMG} ${ELF2IMG}
    )

    add_custom_target(elf2img ALL DEPENDS ${ELF2IMG})
else()
    # Otherwise, we need to build it ourselves
    include(ExternalProject)
    ExternalProject_Add(elf2img
        DOWNLOAD_COMMAND ""
        SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/util/elf2img/"
        CMAKE_ARGS "-DFX3_ELF2IMG=${FX3_ELF2IMG};-DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
        INSTALL_COMMAND ""
    )
    set(ELF2IMG ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/elf2img)
endif()

################################################################################
# Build firmware ELF
################################################################################

# Build an archive of the common object files.
add_library(bladeRF_fx3 STATIC ${SRC_BLADERF})
target_link_libraries(bladeRF_fx3
    "${FX3_LIBRARY_DIR}/libcyfxapi.a"
    "${FX3_LIBRARY_DIR}/libcyu3lpp.a"
    "${FX3_LIBRARY_DIR}/libcyu3threadx.a"
)

if(ENABLE_BLADERF_FIRMWARE)
    add_executable(${BLADERF_FW}.elf ${SRC_BLADERF})
    target_link_libraries(${BLADERF_FW}.elf
        "${FX3_LIBRARY_DIR}/libcyfxapi.a"
        "${FX3_LIBRARY_DIR}/libcyu3lpp.a"
        "${FX3_LIBRARY_DIR}/libcyu3threadx.a"
        "${ARM_NONE_EABI_LIBC}"
        "${ARM_NONE_EABI_LIBGCC}"
        bladeRF_fx3
    )
    set_target_properties(${BLADERF_FW}.elf
        PROPERTIES LINK_FLAGS "-Wl,-Map,output/${BLADERF_FW}.map")
endif()

################################################################################
# Create bootable image from firmware ELF
################################################################################

set(ELF2IMG_WORK_DIR "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

if(ENABLE_BLADERF_FIRMWARE)
    add_custom_command(
        OUTPUT ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.img
        COMMAND ${ELF2IMG} -i ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.elf -o ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.img
        DEPENDS ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.elf
        COMMENT "Creating ${BLADERF_FW}.img. Interrupt vector removal note is expected."
    )

    add_custom_target(${BLADERF_FW}.img ALL
        DEPENDS elf2img ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.elf ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.img)
endif()

################################################################################
# Drop our .gdbinit sample into our build output directory for convenience
################################################################################
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gdb/gdbinit_sample
               ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/.gdbinit
               @ONLY)

=== host/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)
project(bladeRF C)

################################################################################
# Project configuration
################################################################################
add_compile_definitions(NUAND_MODIFICATIONS=1)

# All build output lands in this directory:
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_HELPERS_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/cmake/helpers)
set(CMAKE_HELPERS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/cmake/helpers)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message(STATUS "Build type not specified: defaulting to a release build.")
endif()

set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Build type")
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/modules)

# Firmware <--> Host common files
set(BLADERF_FW_COMMON_INCLUDE_DIR ${CMAKE_CURRENT_LIST_DIR}/../firmware_common)

# FPGA NIOS II <--> Host common files
set(BLADERF_FPGA_COMMON_DIR ${CMAKE_CURRENT_LIST_DIR}/../fpga_common)
set(BLADERF_FPGA_COMMON_INCLUDE_DIR ${BLADERF_FPGA_COMMON_DIR}/include)
set(BLADERF_FPGA_COMMON_SOURCE_DIR ${BLADERF_FPGA_COMMON_DIR}/src)

# Source and headers common amongst host software
set(BLADERF_HOST_COMMON_INCLUDE_DIRS
        ${CMAKE_CURRENT_LIST_DIR}/common/include
        ${CMAKE_CURRENT_BINARY_DIR}/common/include
)

set(BLADERF_HOST_COMMON_SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/common/src)

# CMake >= 2.8.4 no longer defines WIN32. Acknowledge this change.
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

###############################
# Misc. options
###############################
option(ENABLE_LOG_FILE_INFO
        "Enable source file and line number information in log messages."
        ON)

option(BUILD_DOCUMENTATION
        "Enable build and install of manpages and other documentation."
        OFF)

option(TREAT_WARNINGS_AS_ERRORS
       "Treat compiler warnings as errors."
       ON)

if(ENABLE_LOG_FILE_INFO)
    add_definitions(-DLOG_INCLUDE_FILE_INFO)
endif()

################################################################################
# Configure host-specific items
################################################################################
include(TestBigEndian)
TEST_BIG_ENDIAN(BLADERF_BIG_ENDIAN)

# Search for libraries and drivers
include(FindLibUSB)
if(WIN32)
    include(FindCyAPI)
endif()

include(CheckLibraryExists)
check_library_exists(c clock_gettime "time.h" HAVE_CLOCK_GETTIME)

################################################################################
# Build third-party libraries
################################################################################
# TODO: the build will fail unless this is enabled.
option(BUILD_AD936X
       "Include support for the Analog Devices AD936x RFIC."
       ON)
option(BUILD_AD936X_DEBUG
       "Enable debugging output for the AD936x library."
       OFF)
 # We do this prior to the rest of host/common, as the compile options are
# going to be different.
add_subdirectory(common/thirdparty/ad936x)

################################################################################
# Compiler configuration
################################################################################

###############################
# GCC and Clang
###############################
option(ENABLE_GDB_EXTENSIONS "Build with -ggdb3 instead of -g" OFF)

if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR
   ${CMAKE_C_COMPILER_ID} MATCHES  ".*Clang")

    # Personal preference - as much debug info as possible with GDB
    if(${ENABLE_GDB_EXTENSIONS})
        string(REGEX REPLACE "^-g$" "-ggdb3" CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
    endif(${ENABLE_GDB_EXTENSIONS})


    add_definitions(-Wall)
    add_definitions(-Wextra)
    add_definitions(-Wno-unused-parameter)

    if(TREAT_WARNINGS_AS_ERRORS)
        add_definitions(-Werror)
    endif()

    if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
        add_definitions(-DDEBUG=1)
        add_definitions(-O0)
    endif(${CMAKE_BUILD_TYPE} STREQUAL "Debug")

endif(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR
      ${CMAKE_C_COMPILER_ID} MATCHES  ".*Clang")

###############################
# MS Visual Studio
###############################
if(MSVC)
    if(TREAT_WARNINGS_AS_ERRORS)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /WX")
    endif()

    # Prior to V12.0 2013, certain C99 headers we use were not supported.
    # We have to supply our own.
    if(MSVC_VERSION LESS 1800)
        set(MSVC_C99_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/common/include/windows/c99)
    endif()

    # MSVC ships with its own timespec
    add_definitions(-DHAVE_STRUCT_TIMESPEC)
endif(MSVC)

################################################################################
# System configuration
################################################################################

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR CYGWIN)
    set(BLADERF_OS_LINUX 1)

    if(NOT CMAKE_CROSSCOMPILING AND NOT CYGWIN)
        message(STATUS "Checking libc version...")
        try_run(LIBC_VERSION_RUN_RESULT LIBC_VERSION_COMPILE_RESULT
                ${CMAKE_HELPERS_BINARY_DIR}
                ${CMAKE_HELPERS_SOURCE_DIR}/libc_version.c
                RUN_OUTPUT_VARIABLE LIBC_VERSION)

        if(LIBC_VERSION)
            message(STATUS "libc version: ${LIBC_VERSION}")
        else()
            message(WARNING "Unable to determine libc version")
        endif()
    endif(NOT CMAKE_CROSSCOMPILING AND NOT CYGWIN)

elseif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    set(BLADERF_OS_FREEBSD 1)

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(BLADERF_OS_OSX 1)

    # We also need to add some headers that the system will not provide
    set(BLADERF_HOST_COMMON_INCLUDE_DIRS
            ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
            ${CMAKE_CURRENT_LIST_DIR}/common/include/osx
    )

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set(BLADERF_OS_WINDOWS 1)

    # We also need to add some headers that the system will not provide
    set(BLADERF_HOST_COMMON_INCLUDE_DIRS
            ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
            ${CMAKE_CURRENT_LIST_DIR}/common/include/windows
    )

    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
else()
    message(FATAL_ERROR "Unsupported host operating system: ${CMAKE_SYSTEM_NAME}")
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/common/include/host_config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/common/include/host_config.h
    @ONLY
)

# OSX
if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
    if(${isSystemDir} STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    endif()
endif()

################################################################################
# Process subdirectories
################################################################################
add_subdirectory(libraries)
add_subdirectory(misc)
add_subdirectory(utilities)
add_subdirectory(common)

################################################################################
# Create uninstall target
################################################################################
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

################################################################################
# Windows-only, Post build: Copy libraries to our build output directory
################################################################################
if(WIN32 AND NOT CMAKE_CROSSCOMPILING)
    if(LIBUSB_FOUND)
        set(WIN_RUNTIME_ITEMS ${WIN_RUNTIME_ITEMS}
            "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/licenses/libusb/COPYING"
            "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/libusb-1.0.dll")

        # The libusb Windows release does not appear to include a COPYING file.
        # Since it's LGPLv2.1, we'll copy the equivalent license from our
        # license directory
        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/licenses/libusb/COPYING"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${CMAKE_CURRENT_SOURCE_DIR}/../legal/licenses/LICENSE.LGPLv2.1"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/licenses/libusb/COPYING"
            COMMENT "Copying libusb license to output directory..."
        )

        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/libusb-1.0.dll"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${LIBUSB_PATH}/${LIBUSB_LIBRARY_PATH_SUFFIX}/libusb-1.0.dll"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/"
            COMMENT "Copying libusb-1.0.dll to output directory..."
        )
    endif(LIBUSB_FOUND)

    if(CYAPI_FOUND)
        set(WIN_RUNTIME_ITEMS ${WIN_RUNTIME_ITEMS}
            "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/licenses/Cypress/license.txt"
            "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/cyusb3.inf"
            "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/cyusb3.sys"
            "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/cyusb3.cat"
            "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/${CYUSB3_WDF_COINSTALLER}"
        )

        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/licenses/Cypress/license.txt"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${CYPRESS_LICENSE}"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/licenses/Cypress/license.txt"
            COMMENT "Copying Cypress License to output directory..."
        )

        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/cyusb3.inf"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${CMAKE_CURRENT_SOURCE_DIR}/${CYUSB3_INF}"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/"
            COMMENT "Copying cyusb3.inf to output directory..."
        )

        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/cyusb3.sys"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${CYUSB3_DRIVER_DIR}/cyusb3.sys"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/"
            COMMENT "Copying cyusb3.sys to output directory..."
        )

        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/cyusb3.cat"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${CYUSB3_DRIVER_DIR}/cyusb3.cat"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/"
            COMMENT "Copying cyusb3.cat to output directory..."
        )

        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/${CYUSB3_WDF_COINSTALLER}"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${CYUSB3_DRIVER_DIR}/${CYUSB3_WDF_COINSTALLER}"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/drivers/CyUSB3/"

=== host/libraries/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)
add_subdirectory(libbladeRF)

# Conditionally add the test directory
option(TEST_LIBBLADERF "Enables libbladeRF test output" ON)
if(TEST_LIBBLADERF)
    message(STATUS "libbladeRF_test: enabled")
    add_subdirectory(libbladeRF_test)
else()
    message(STATUS "libbladeRF_test: disabled")
endif()

=== host/misc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)
add_subdirectory(udev)

=== host/utilities/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)

option(BUILD_BLADERF_FSK "Build bladeRF FSK" ON)

if(NOT IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bladeRF-fsk/c)
    message(STATUS "bladeRF-fsk: Attempting to initialize missing submodule")

    find_package(Git QUIET)

    if(Git_FOUND)
        execute_process(
            COMMAND ${Git_EXECUTABLE} submodule init
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
        execute_process(
            COMMAND ${Git_EXECUTABLE} submodule update
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    endif()
endif()

if(NOT IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bladeRF-fsk/c)
    message(FATAL_ERROR "Directory ${CMAKE_CURRENT_SOURCE_DIR}/bladeRF-fsk was not found. "
                        "It appears that this submodule has not been properly "
                        "initialized. Please run 'git submodule init' and "
                        "'git submodule update', and then re-run cmake.")
endif()

add_subdirectory(bladeRF-cli)
add_subdirectory(bladeRF-update)
if(NOT MSVC)
    add_subdirectory(bladeRF-power)
    if(BUILD_BLADERF_FSK)
        add_subdirectory(bladeRF-fsk/c)
    endif()
endif()

=== host/libraries/libbladeRF/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)
project(libbladeRF C)


################################################################################
# Version information
################################################################################

set(VERSION_INFO_MAJOR  2)
set(VERSION_INFO_MINOR  6)
set(VERSION_INFO_PATCH  0)
set(LIBBLADERF_VERSION
  ${VERSION_INFO_MAJOR}.${VERSION_INFO_MINOR}.${VERSION_INFO_PATCH})


if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")
set(LIBVER "${VERSION_INFO_BASE}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/version.h
    @ONLY
)

if(MSVC)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/bladerf.rc.in
        ${CMAKE_CURRENT_BINARY_DIR}/bladerf.rc
        @ONLY
    )
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
include(GNUInstallDirs)
endif (NOT CMAKE_INSTALL_LIBDIR)

if (NOT CMAKE_INSTALL_DOCDIR)
include(GNUInstallDirs)
endif (NOT CMAKE_INSTALL_DOCDIR)

# Fall back to just "lib" if the item provided by GNUInstallDirs doesn't exist
# For example, on Ubuntu 13.10 with CMake 2.8.11.2,
# /usr/lib/${CMAKE_LIBRARY_ARCHITECTURE} doesn't exist.
if (NOT EXISTS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    message(STATUS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} does not exist. Defaulting libbladeRF install location to ${CMAKE_INSTALL_PREFIX}/lib.")
    set(CMAKE_INSTALL_LIBDIR lib)
endif()


################################################################################
# Configuration options
################################################################################

option(ENABLE_LIBBLADERF_LOGGING "Enable log messages in libbladeRF." ON)

option(ENABLE_LIBBLADERF_SYSLOG "Enable logging to syslog (Linux/OSX)" OFF)

option(BUILD_LIBBLADERF_DOCUMENTATION "Build libbladeRF documentation. Requries Doxygen." ${BUILD_DOCUMENTATION})
if(NOT ${BUILD_DOCUMENTATION})
    set(BUILD_LIBBLADERF_DOCUMENTATION OFF)
endif()

option(BUILD_LIBBLADERF_DOC_EXAMPLES "Compile examples that are included in Doxygen documentation (mainly for QA purposes)." ${BUILD_LIBBLADERF_DOCUMENTATION})

option(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE
      "Enable log_verbose() calls in the sync interface's data path. Note that this may harm performance."
      OFF
)

option(ENABLE_LIBBLADERF_NIOS_ACCESS_LOG_VERBOSE
       "Enable log_verbose() calls on frequently-used functions in nios_access.c. Note that this may produce a lot of log output."
       OFF
)

option(ENABLE_LOCK_CHECKS
       "Enable checks for lock acquisition failures (e.g., deadlock)"
       OFF
)

option(ENABLE_USB_DEV_RESET_ON_OPEN
       "Perform a USB port reset when opening a device. This works around an issue on some Linux USB 3.0 setups that prevents a device from being opened after an application crash or unclean exit."
       ${BLADERF_OS_LINUX}
)

option(ENABLE_RFIC_TIMING_CALIBRATION
       "Perform timing calibration on the RFIC digital interface during initialization. This is only implemented on AD936x-based hardware."
       OFF
)


##############################
# Backend Support
##############################

option(ENABLE_BACKEND_USB
    "Enable USB backends. Required when using the bladeRF with a host machine."
    ON
)

option(ENABLE_BACKEND_LIBUSB
    "Enable libusb backend support."
    ${LIBUSB_FOUND}
)

option(ENABLE_BACKEND_CYAPI
    "Enable CYAPI backend support."
    ${CYAPI_FOUND}
)

option(ENABLE_BACKEND_DUMMY
    "Enable dummy backend support. This is only useful for some developers."
    OFF
)

# Ensure we've got at least one backend enabled
if(NOT ENABLE_BACKEND_LIBUSB
   AND NOT ENABLE_BACKEND_LINUX_DRIVER
   AND NOT ENABLE_BACKEND_CYAPI
   AND NOT ENABLE_BACKEND_DUMMY)
    message(FATAL_ERROR
            "Cannot enable any libbladeRF backends due to missing library support. "
            "Consider installing libusb dev package (libusb-1.0-0-dev on Ubuntu). "
            "No libbladeRF backends are enabled. "
            "Please enable one or more backends." )
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/backend/backend_config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/backend/backend_config.h
    @ONLY
)


################################################################################
# Additional compiler options
################################################################################

if(ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DLOGGING_ENABLED)
endif()

if(ENABLE_LIBBLADERF_SYSLOG)
    add_definitions(-DLOG_SYSLOG_ENABLED)
endif()

if(ENABLE_LOCK_CHECKS)
    add_definitions(-DENABLE_LOCK_CHECKS)
endif()

if(ENABLE_RFIC_TIMING_CALIBRATION)
    add_definitions(-DENABLE_AD9361_DIGITAL_INTERFACE_TIMING_VERIFICATION)
endif()

if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR
   ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")

    # Doing this manually instead of via add_compiler_export_flags() since
    # the GenerateExportHeader module appears to break for C-only projects:
    #
    # http://www.cmake.org/pipermail/cmake-commits/2012-August/013142.html
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()

# We define LIBBLADERF_SEARCH_PREFIX to specify where libbladeRF should look
# for files, such as FPGA bitstreams to autoload.
#
# This defaults to the value of ${CMAKE_INSTALL_PREFIX}. However,
# users may wish to override when cross compiling.
if(LIBBLADERF_SEARCH_PREFIX_OVERRIDE)
    add_definitions(-DLIBBLADERF_SEARCH_PREFIX="${LIBBLADERF_SEARCH_PREFIX_OVERRIDE}")
else()
    add_definitions(-DLIBBLADERF_SEARCH_PREFIX="${CMAKE_INSTALL_PREFIX}")
endif()


################################################################################
# Include paths
################################################################################

set(LIBBLADERF_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
    ${BLADERF_FW_COMMON_INCLUDE_DIR}
    ${BLADERF_FPGA_COMMON_INCLUDE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/src
)


################################################################################
# Build dependencies
################################################################################

if(MSVC)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${MSVC_C99_INCLUDES})

    set(HAVE_THREADS true)
else(MSVC)
    find_package(Threads REQUIRED)
    if(Threads_FOUND)
        set(HAVE_THREADS true)
    else()
        set(HAVE_THREADS false)
    endif()
endif(MSVC)

if(BLADERF_OS_OSX)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} /usr/include/malloc)
endif()

if (NOT HAVE_THREADS)
    message(FATAL_ERROR "pthreads not found. This is required to build libbladeRF.")
endif()

if(NOT ENABLE_BACKEND_USB)
    set(ENABLE_BACKEND_LIBUSB OFF)
    set(ENABLE_BACKEND_LINUX_DRIVER OFF)
endif()

if(ENABLE_BACKEND_LIBUSB)
    if(NOT LIBUSB_FOUND)
        message(FATAL_ERROR "libusb-1.0 not found. This is required to use the libbladeRF libusb backend. For binary releases, try setting LIBUSB_PATH.")
    else(NOT LIBUSB_FOUND)
        if(LIBUSB_VERSION)
            if(NOT LIBUSB_VERSION VERSION_LESS "1.0.10")
                add_definitions(-DHAVE_LIBUSB_GET_VERSION)
            endif()

            if(WIN32)
                # We require v1.0.19 because it provides Windows 8 USB 3.0
                # speed detection fixes, additional AMD/Intel USB 3.0 root
                # hub support, and some fixes to issues reported on v1.0.18
                # that yielded corrupted samples.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.19")
                    message(FATAL_ERROR "libusb v1.0.19 is required in Windows.\n"
                                        "Please update libusb or consider using the Cypress backend if this is not possible.\n"
                                        "Detected version: ${LIBUSB_VERSION}\n")
                endif()
            elseif(APPLE)
                # A number of important changes were included in libusb
                # v1.0.16 hrough v1.0.18, including SuperSpeed support, 64-bit support,
                # and various build and crash fixes.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.18")
                    message(FATAL_ERROR "libusb v1.0.18 is required in OS X. Please update libusb."
                                        "Detected version: ${LIBUSB_VERSION}\n")
                endif()
            elseif(UNIX)
                # A number of reported issues supposedly became resolved after
                # updating to >= 1.0.16.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.16")
                    message(WARNING "\nlibusb >= 1.0.16 is HIGHLY recommended. "
                                    "If you experience issues or poor performance, please try updating libusb.\n"
                                    "Detected version: ${LIBUSB_VERSION}")
                endif()
            else()
                message(WARNING "Unexpected system type. Please report this warning to developers.")
            endif()
        elseif(BLADERF_OS_FREEBSD)
            message(STATUS "Using FreeBSD's built-in libusb implementation.")
        else()
            message(WARNING "Not checking libbladeRF/libusb compatibility because LIBUSB_VERSION is not defined.")
        endif()
        set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${LIBUSB_INCLUDE_DIRS})
    endif(NOT LIBUSB_FOUND)
endif(ENABLE_BACKEND_LIBUSB)

if(ENABLE_BACKEND_CYAPI)
    find_package(CyAPI REQUIRED)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${CYAPI_INCLUDE_DIRS})
endif(ENABLE_BACKEND_CYAPI)

if(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE AND ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DENABLE_LIBBLADERF_SYNC_LOG_VERBOSE)
endif()

if(ENABLE_LIBBLADERF_NIOS_ACCESS_LOG_VERBOSE AND ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DENABLE_LIBBLADERF_NIOS_ACCESS_LOG_VERBOSE)
endif()

if(ENABLE_USB_DEV_RESET_ON_OPEN)
    add_definitions(-DENABLE_USB_DEV_RESET_ON_OPEN=1)
endif()

if(BUILD_AD936X)
    set(LIBBLADERF_LIBS ${LIBBLADERF_LIBS} ad936x)
endif(BUILD_AD936X)

include_directories(${LIBBLADERF_INCLUDES})


################################################################################
# Configure source files
################################################################################
set(LIBBLADERF_SOURCE_BLADERF2
        ${BLADERF_FPGA_COMMON_SOURCE_DIR}/ad936x_helpers.c
        ${BLADERF_FPGA_COMMON_SOURCE_DIR}/bladerf2_common.c
        src/board/bladerf2/bladerf2.c
        src/board/bladerf2/capabilities.c
        src/board/bladerf2/common.c
        src/board/bladerf2/compatibility.c
        src/board/bladerf2/rfic_fpga.c
        src/board/bladerf2/rfic_host.c
)

set(LIBBLADERF_SOURCE
        src/backend/backend.c
        src/driver/spi_flash.c
        src/driver/fx3_fw.c
        src/driver/fpga_trigger.c
        src/driver/si5338.c
        src/driver/ina219.c
        src/driver/dac161s055.c
        src/driver/smb_clock.c
        src/board/bladerf1/bladerf1.c
        src/board/bladerf1/capabilities.c
        src/board/bladerf1/compatibility.c
        src/board/bladerf1/calibration.c
        src/board/bladerf1/flash.c
        src/board/bladerf1/image.c
        src/board/board.c
        src/expansion/xb100.c
        src/expansion/xb200.c
        src/expansion/xb300.c
        src/streaming/async.c
        src/streaming/sync.c
        src/streaming/sync_worker.c
        src/init_fini.c
        src/helpers/timeout.c
        src/helpers/file.c
        src/helpers/version.c
        src/helpers/wallclock.c
        src/helpers/interleave.c
        src/helpers/configfile.c
        src/version.h
        src/devinfo.c
        src/device_calibration.c
        src/bladerf.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/sha256.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/log.c
        ${BLADERF_FPGA_COMMON_SOURCE_DIR}/lms.c

=== host/libraries/libbladeRF_test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)

add_subdirectory(test_async)
add_subdirectory(test_bootloader_recovery)
add_subdirectory(test_c)
#add_subdirectory(test_config_file)
add_subdirectory(test_clock_select)
add_subdirectory(test_cpp)
add_subdirectory(test_ctrl)
add_subdirectory(test_freq_hop)
add_subdirectory(test_fw_check)
add_subdirectory(test_open)
add_subdirectory(test_oversample)
add_subdirectory(test_packet)
add_subdirectory(test_parse)
add_subdirectory(test_peripheral_timing)
add_subdirectory(test_gain_compare)
add_subdirectory(test_gain_calibration)
add_subdirectory(test_repeater)
add_subdirectory(test_quick_retune)
add_subdirectory(test_repeated_stream)
add_subdirectory(test_rx_discont)
add_subdirectory(test_scheduled_retune)
add_subdirectory(test_streaming)
add_subdirectory(test_sync)
add_subdirectory(test_timestamps)
add_subdirectory(test_tune_timing)
add_subdirectory(test_unused_sync)
add_subdirectory(test_version)
add_subdirectory(test_digital_loopback)
add_subdirectory(test_interleaver)
add_subdirectory(test_rx_meta)
add_subdirectory(test_fpga_load)

option(TEST_REGRESSION "Include regression tests" OFF)
if(TEST_REGRESSION)
    add_subdirectory(test_regression)
endif()

configure_file(requirements.txt
               ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/requirements.txt
               FILE_PERMISSIONS OWNER_EXECUTE OWNER_READ
               COPYONLY)

configure_file(setup_env.sh
               ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/setup_env.sh
               FILE_PERMISSIONS OWNER_EXECUTE OWNER_READ
               COPYONLY)

=== host/libraries/libbladeRF_test/requirements.txt ===
contourpy>=1.1.1
cycler==0.12.1
fonttools==4.56.0
kiwisolver>=1.4.7
matplotlib>=3.7.5
numpy>=1.24.4
packaging==24.2
pandas>=2.0.3
pillow>=10.4.0
pyparsing>=3.1.4
python-dateutil==2.9.0.post0
pytz==2025.1
scipy>=1.8.0
six==1.17.0
tzdata==2025.1

=== host/misc/udev/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    SET(SYSTEM_IS_LINUX TRUE)
    SET(UDEV_OPTION_DEFAULT ON)
else()
    SET(SYSTEM_IS_LINUX FALSE)
    SET(UDEV_OPTION_DEFAULT OFF)
endif()

option(INSTALL_UDEV_RULES
    "Install udev rules for the nuand bladeRF"
    ${UDEV_OPTION_DEFAULT}
)

set(UDEV_RULES_PATH
    "/etc/udev/rules.d"
    CACHE STRING
    "Target directory for udev rule installation. Ensure you have permissions to write to this directory."
)

set(BLADERF_GROUP "plugdev" CACHE STRING "Group to associate bladeRF devices with in udev rules")

set(BLADERF_UDEV_FILES
    88-nuand-bladerf1.rules
    88-nuand-bladerf2.rules
    88-nuand-bootloader.rules
)

if(SYSTEM_IS_LINUX)
    if(INSTALL_UDEV_RULES)
        message(STATUS  "nuand bladeRF udev rules will be installed to '${UDEV_RULES_PATH}' upon running 'make install'")
        foreach(udevfile IN ITEMS ${BLADERF_UDEV_FILES})
            configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${udevfile}.in
                           ${CMAKE_CURRENT_BINARY_DIR}/${udevfile}
                           @ONLY
                          )

            install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${udevfile}
                    DESTINATION ${UDEV_RULES_PATH}
                    COMPONENT "udev_rules")
        endforeach(udevfile)
    else()
        message(STATUS
                "nuand bladeRF udev rules will not be installed because INSTALL_UDEV_RULES=OFF"
               )
    endif(INSTALL_UDEV_RULES)
else()
    if(INSTALL_UDEV_RULES)
        message(STATUS "udev rules not supported on this platform. Hide this message via -DINSTALL_UDEV_RULES=OFF")
    endif(INSTALL_UDEV_RULES)
endif()

=== host/utilities/bladeRF-cli/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)
project(bladeRF-cli C)

################################################################################
# Version information
################################################################################

set(VERSION_INFO_MAJOR  1)
set(VERSION_INFO_MINOR  10)
set(VERSION_INFO_PATCH  0)

if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/version.h
    @ONLY
)

################################################################################
# Build dependencies
################################################################################
find_package(LibTecla)
find_package(LibEdit)

if(NOT MSVC)
	find_package(Threads REQUIRED)
endif(NOT MSVC)

find_program(PANDOC_EXECUTABLE pandoc)
find_program(BASH_EXECUTABLE bash)

if(PANDOC_EXECUTABLE AND BASH_EXECUTABLE)
    set(CAN_BUILD_INTERACTIVE_HELP ON)
else()
    set(CAN_BUILD_INTERACTIVE_HELP OFF)
endif()

################################################################################
# Configuration options
################################################################################

option(ENABLE_LIBTECLA
        "Enable the use of libtecla, if available.")

option(ENABLE_LIBEDIT
        "Enable the use of libtecla, if available.")

option(BUILD_BLADERF_CLI_DOCUMENTATION
        "Build bladeRF-cli man page. Requires help2man."
        ${BUILD_DOCUMENTATION})

option(BUILD_BLADERF_CLI_INTERACTIVE_HELP
        "Rebuild bladeRF-cli interactive help. Requires pandoc."
        ${CAN_BUILD_INTERACTIVE_HELP})

if(NOT ${BUILD_DOCUMENTATION})
    set(BUILD_BLADERF_CLI_DOCUMENTATION OFF)
endif()

if((NOT CAN_BUILD_INTERACTIVE_HELP) AND (BUILD_BLADERF_CLI_INTERACTIVE_HELP))
    message(FATAL_ERROR "BUILD_BLADERF_CLI_INTERACTIVE_HELP was forced ON, "
            "but there are missing prerequisites!")
endif()

if(ENABLE_LIBTECLA)
    if((NOT LIBTECLA_INCLUDE_DIR) OR (NOT LIBTECLA_LIBRARIES))
        message(FATAL_ERROR "ENABLE_LIBTECLA was forced ON, but libtecla "
                "cannot be found!")
    endif()
endif()
if(ENABLE_LIBEDIT)
    if((NOT LIBEDIT_INCLUDE_DIR) OR (NOT LIBEDIT_LIBRARIES))
        message(FATAL_ERROR "ENABLE_LIBEDIT was forced ON, but editline "
                "cannot be found!")
    endif()
endif()

################################################################################
# Regenerate interactive help
################################################################################
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc)

if(BUILD_BLADERF_CLI_INTERACTIVE_HELP)
    # Do a quick test to make sure we have everything we need...
    execute_process(
        COMMAND ${BASH_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/generate.bash
                --pandoc=${PANDOC_EXECUTABLE}
                --test
                ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/interactive-help.md
        RESULT_VARIABLE INTERACTIVE_HELP_GENERATOR_FAILED
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc
    )

    if(INTERACTIVE_HELP_GENERATOR_FAILED)
        message(FATAL_ERROR "generate.bash failed! Try disabling "
                "BUILD_BLADERF_CLI_INTERACTIVE_HELP, or fix the above error.")
    endif()

    # Run the generation script during build
    message(STATUS "Will regenerate bladeRF-cli interactive help")
    add_custom_command(
        OUTPUT src/cmd/doc/cmd_help.h src/cmd/doc/cmd_help.man
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/generate.bash
        COMMAND ${BASH_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/generate.bash
                --pandoc=${PANDOC_EXECUTABLE}
                ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/interactive-help.md
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc
    )
else()
    # Re-use old cmd_help.h and cmd_help.man
    message(STATUS "Reusing existing interactive help for bladeRF-cli")
    add_custom_command(
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.h.in
        OUTPUT src/cmd/doc/cmd_help.h
        COMMAND ${CMAKE_COMMAND} -E copy
            ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.h.in
            ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.h
    )
    add_custom_command(
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.man.in
        OUTPUT src/cmd/doc/cmd_help.man
        COMMAND ${CMAKE_COMMAND} -E copy
            ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.man.in
            ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.man
    )
endif()

################################################################################
# Include paths
################################################################################
set(CLI_INCLUDE_DIRS
       ${CMAKE_CURRENT_SOURCE_DIR}/src
       ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd
       ${CMAKE_CURRENT_SOURCE_DIR}/src/input
       ${CMAKE_CURRENT_BINARY_DIR}/src
       ${CMAKE_CURRENT_BINARY_DIR}/src/cmd
       ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
       ${libbladeRF_SOURCE_DIR}/include
       ${BLADERF_FW_COMMON_INCLUDE_DIR}
)

if(MSVC)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS} ${MSVC_C99_INCLUDES})
endif()


message(STATUS "libtecla ${ENABLE_LIBTECLA} ${LIBTECLA_FOUND}")
message(STATUS "libedit ${ENABLE_LIBEDIT} ${LIBEDIT_FOUND}")
if(ENABLE_LIBTECLA OR (LIBTECLA_FOUND AND NOT ENABLE_LIBEDIT))
    message(STATUS "libtecla support enabled")
    set(ENABLE_LIBTECLA ON)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS} ${LIBTECLA_INCLUDE_DIR})
elseif(ENABLE_LIBEDIT OR LIBEDIT_FOUND)
    message(STATUS "editline support enabled")
    set(ENABLE_LIBEDIT ON)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS} ${LIBEDIT_INCLUDE_DIR})
endif()

if(MSVC)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS}
        ${BLADERF_HOST_COMMON_INCLUDE_DIRS}/windows
    )
endif()

if(APPLE)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS}
        ${BLADERF_HOST_COMMON_INCLUDE_DIRS}/osx
    )
endif()

include_directories(${CLI_INCLUDE_DIRS})

################################################################################
# Configure source files
################################################################################
set(BLADERF_CLI_SOURCE
        src/main.c
        src/common.c
        src/cmd/calibrate.c
        src/cmd/cmd.c
        src/cmd/doc/cmd_help.h
        src/cmd/erase.c
        src/cmd/flash_backup.c
        src/cmd/flash_image.c
        src/cmd/flash_init_cal.c
        src/cmd/flash_restore.c
        src/cmd/fw_log.c
        src/cmd/generate.c
        src/cmd/info.c
        src/cmd/jump_boot.c
        src/cmd/lms_reg_info.c
        src/cmd/load.c
        src/cmd/mimo.c
        src/cmd/open.c
        src/cmd/peek.c
        src/cmd/peekpoke.c
        src/cmd/poke.c
        src/cmd/printset.c
        src/cmd/printset_hardware.c
        src/cmd/printset_impl.c
        src/cmd/printset_xb.c
        src/cmd/probe.c
        src/cmd/recover.c
        src/cmd/rx.c
        src/cmd/rxtx.c
        src/cmd/trigger.c
        src/cmd/tx.c
        src/cmd/version.c
        src/cmd/xb.c
        src/cmd/xb100.c
        src/cmd/xb200.c
        src/cmd/xb300.c
        src/input/input.c
        src/input/script.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/dc_calibration.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/log.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/str_queue.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/parse.c
)

# Select the input mode (and script handling) backend
if(ENABLE_LIBTECLA)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/input/tecla.c)
elseif(ENABLE_LIBEDIT)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/input/editline.c)
else()
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/input/fgets.c)
endif()

if(MSVC)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE}
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/getopt_long.c
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/clock_gettime.c
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/nanosleep.c
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/setenv.c
    )
endif()

if(APPLE)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE}
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/osx/clock_gettime.c
    )
endif()

add_executable(bladeRF-cli ${BLADERF_CLI_SOURCE})

################################################################################
# Build configuration
################################################################################
set(CLI_LINK_LIBRARIES
    libbladerf_shared
    ${CMAKE_THREAD_LIBS_INIT}
)

if(NOT MSVC)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} m)
endif(NOT MSVC)

if(ENABLE_LIBTECLA)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBTECLA_LIBRARIES})

    # On a few tests Linux distros, libtecla is not build against
    # ncurses. However, folks have reported that builds on OSX use it
    if(CMAKE_HOST_APPLE)
        set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ncurses)
    endif(CMAKE_HOST_APPLE)
elseif(ENABLE_LIBEDIT)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBEDIT_LIBRARIES})
endif(ENABLE_LIBTECLA)

if(LIBC_VERSION)
    # clock_gettime() was moved from librt -> libc in 2.17
    if(${LIBC_VERSION} VERSION_LESS "2.17")
        set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} rt)
    endif()
endif()

target_link_libraries(bladeRF-cli ${CLI_LINK_LIBRARIES})

################################################################################
# Man pages
################################################################################
if(BUILD_BLADERF_CLI_DOCUMENTATION)
    find_program(HELP2MAN_EXECUTABLE help2man)

    if(HELP2MAN_EXECUTABLE)
        message(STATUS "Will build man page for bladeRF-cli.")

        if(NOT DEFINED MAN_INSTALL_DIR)
            set(MAN_INSTALL_DIR share/man)
        endif(NOT DEFINED MAN_INSTALL_DIR)

        # Build actual man page
        add_custom_command(
            OUTPUT bladeRF-cli.1
            DEPENDS bladeRF-cli src/cmd/doc/cmd_help.man
            COMMAND ${HELP2MAN_EXECUTABLE}
                --no-info --no-discard-stderr
                --opt-include=${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/bladeRF-cli.h2m
                --opt-include=${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.man
                --opt-include=${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/common.h2m
                --output=bladeRF-cli.1
                ./bladeRF-cli
            WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        )

        install(
            FILES ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/bladeRF-cli.1
            DESTINATION ${MAN_INSTALL_DIR}/man1
        )

        add_custom_target(bladeRF-cli-manpage ALL DEPENDS bladeRF-cli.1)

    else(HELP2MAN_EXECUTABLE)
        message(FATAL_ERROR "Could not find help2man. bladeRF-cli man page "
                "cannot be built.")
    endif(HELP2MAN_EXECUTABLE)
else(BUILD_BLADERF_CLI_DOCUMENTATION)
    message(STATUS "Not building man page for bladeRF-cli. "
            "(BUILD_BLADERF_CLI_DOCUMENTATION is OFF)")
endif(BUILD_BLADERF_CLI_DOCUMENTATION)

################################################################################
# Installation
################################################################################
if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR bin)
endif()

install(TARGETS bladeRF-cli DESTINATION ${BIN_INSTALL_DIR})

################################################################################
# Informational output
################################################################################
message(STATUS "Configured to build bladeRF-cli version: ${VERSION_INFO}")

=== host/utilities/bladeRF-power/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10...3.27)
project(bladeRF-power LANGUAGES C)

set (CURSES_NEED_NCURSES TRUE)
set (CURSES_NEED_WIDE TRUE)

if(APPLE)
    if(EXISTS "/opt/homebrew/opt/ncurses")
        list(APPEND CMAKE_PREFIX_PATH "/opt/homebrew/opt/ncurses")
    elseif(EXISTS "/usr/local/opt/ncurses")
        list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/ncurses")
    else()
        message(WARNING "Homebrew ncurses not found. Install it if the build is failing: brew install ncurses")
    endif()
endif()

find_package(Curses REQUIRED)

include_directories(
    ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
    ${libbladeRF_SOURCE_DIR}/include
    ./include)

add_executable(${PROJECT_NAME}
    ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
    src/init.c
    src/helpers.c
    src/window.c
    src/filter.c
    src/text.c
    src/main.c)

target_compile_options(${PROJECT_NAME} PRIVATE -Wall -Wextra -Werror)
target_link_libraries(${PROJECT_NAME}
    libbladerf_shared
    m
    ${BLADERF_HOST_COMMON_LIBRARIES}
    ${CURSES_LIBRARIES}
    ncurses)

install(TARGETS ${PROJECT_NAME} DESTINATION ${BIN_INSTALL_DIR})

=== debian/changelog ===
bladerf (2024.07) noble; urgency=medium

  * 2024.07 Release 2024.07

 -- Robert Ghilduta (Nuand LLC) <robert.ghilduta@nuand.com>  Fri, 12 Jul 2024 03:32:13 -0400

bladerf (2021.10) unstable; urgency=low

  * Release for 2021.10 tag
  * Fix up packet mode bugs
  * Add Wishbone master core as NiOS peripheral
  * Fix several bugs in packet mode buffering mechanism
  * Add Wishbone master core as NiOS peripheral
  * Add support for bladeRF 2.0 micro xA5.

 -- Robert Ghilduta (Nuand LLC) <robert.ghilduta@nuand.com>  Tue, 16 Feb 2021 00:50:56 -0500

bladerf (2021.03) unstable; urgency=low

  * Release for 2021.03 tag
  * Added packet mode format BLADERF_FORMAT_PACKET_META. libbladeRF is able to
  * exchange variable length packets with the HDL if packet mode is enabled
  * Added RFIC parameters for burst waveforms
  * Ability to query backend for handle and lock
  * Variable length packet support for PACKET_META mode
  * Indicate presence of packet cores in FPGA
  * Add packet mode. The HDL fabric is able to exchange variable length
  * packets with the host
  * Added packet_generator as an example for how to send packets to the host
  * Added bladeRF 2.0 micro headless example variant "foxhunt"
  * Fix metadata related arithmetic and logic


 -- Robert Ghilduta (Nuand LLC) <robert.ghilduta@nuand.com>  Tue, 16 Feb 2021 00:50:56 -0500

bladerf (2019.07) unstable; urgency=low

  * Release for 2019.07 tag
  * Various libbladeRF and HDL fixes
  * FPGA bitstream v0.11.2, FX3 FW v2.3.2, libbladeRF v2.2.1, bladeRF-cli
    v1.8.0

 -- Robert Ghilduta (Nuand LLC) <robert.ghilduta@nuand.com>  Thu, 01 Aug 2019 22:54:28 -0400

bladerf (2018.12-rc2) unstable; urgency=low

  * Release candidate 2 for 2018.12. Please see the top-level CHANGELOG file,
    as well as the sub-project CHANGELOG files, for more details.
  * AD936x RFIC vendor library code moved to thirdparty/
  * FPGA bitstream v0.10.2, FX3 FW v2.3.1, libbladeRF v2.2.0, bladeRF-cli
    v1.7.1

 -- Rey Sabrina Tucker (Nuand LLC) <rey.tucker@nuand.com>  Fri, 21 Dec 2018 16:52:49 -0500

bladerf (2018.10-rc1) unstable; urgency=low

  * Release candidate 1 for 2018.10. Please see the top-level CHANGELOG file,
    as well as the sub-project CHANGELOG files, for more details.
  * control: fix bladeRF 2.0 Micro xA4/xA9 nomenclature
  * libbladerf-doc: new package, containing doxygen-generated libbladeRF API
    documentation
  * FPGA bitstream v0.9.0, FX3 FW v2.3.1, libbladeRF v2.1.0, bladeRF-cli
    v1.7.0

 -- Rey Sabrina Tucker (Nuand LLC) <rey.tucker@nuand.com>  Tue, 30 Oct 2018 17:06:11 -0400

bladerf (2018.08) unstable; urgency=low

  * debian: update packaging files (#596)
  * Improve bladerf_gain_mode documentation (#595)
  * Don't warn about libusb version on FreeBSD (#594)
  * FPGA bitstream v0.7.3, FX3 FW v2.2.0, libbladeRF v2.0.2, bladeRF-cli
    v1.6.1

 -- Rey Sabrina Tucker (Nuand LLC) <rey.tucker@nuand.com>  Thu, 30 Aug 2018 18:01:12 -0400

bladerf (2018.08-rc3) unstable; urgency=low

  * Release candidate 3 for the 2018.08 release
  * Detect and handle a bladeRF Micro that is running old firmware to allow
    re-flashing without recovery mode (#578)
  * bladeRF1: bladerf_set_gain_mode returning BLADERF_ERR_UNSUPPORTED is no
    longer fatal (#542)
  * bladeRF1: only check AGC DC LUT setting when enabling AGC
  * bladeRF1: typo fix in set_tx_gain (#580)
  * xb200: check for null xb_data before dereferencing it (#575)
  * bladeRF2: cache factory trimdac value at initialization; preserve trimdac
    disable state on bladerf2_trim_dac_write (#582)
  * bladeRF2: bladerf_clock_select: replace CLOCK_SELECT_VCTCXO with
    CLOCK_SELECT_ONBOARD for clarity (#585)
  * Improvements to the release notes (#583)
  * bladeRF-cli: Add 200 ms delay before probing PLL lock status (#587)
  * "set loopback" help dialog aware of board type (#566)
  * FPGA bitstream v0.7.3, FX3 FW v2.2.0, libbladeRF v2.0.1, bladeRF-cli
    v1.6.1

 -- Rey Tucker <rey.tucker@nuand.com>  Fri, 24 Aug 2018 16:19:32 -0400

bladerf (2018.08-rc2) unstable; urgency=low

  * Release candidate 2 for the 2018.08 release
  * Fix builds on 32-bit architectures
  * Fix builds on FreeBSD
  * Fix Debian/Ubuntu packaging

 -- Rey Tucker <pgp@reytucker.us>  Thu, 16 Aug 2018 19:55:00 -0400

bladerf (2018.08-rc1) unstable; urgency=low

  * Release candidate 1 for the 2018.08 release
  * Adds support for the bladeRF 2.0 Micro
  * Major version number change: libbladerf1 is now libbladerf2
  * FPGA bitstream v0.7.3, FX3 FW v2.2.0, libbladeRF v2.0.0, bladeRF-cli v1.6.0

 -- Rey Tucker <pgp@reytucker.us>  Wed, 15 Aug 2018 21:07:42 -0400

bladerf (2017.12-rc1) unstable; urgency=low

  * Release candidate 1 for the 2017.12 release
  * FPGA bitstream v0.7.1, FX3 FW v2.0.0, libbladeRF v1.9.0, bladeRF-cli v1.5.1

 -- Rey Tucker <pgp@reytucker.us>  Fri, 08 Dec 2017 11:35:12 -0500

bladerf (2017.07) unstable; urgency=low

  [ Robert Ghilduta ]
  * Add Automatic Gain Control

  [ Rey Tucker ]
  * debian: fix permissions on FPGA and firmware binaries after downloading

 -- Robert Ghilduta <robert.ghilduta@nuand.com>  Sun, 02 Jul 2017 21:14:15 -0400

bladerf (2016.06) unstable; urgency=low

  * Added synchronization trigger functionality
  * Added SMB clock port control to libbladeRF API
  * Added XB-300 support
  * Added detection of v2.0.0 firmware series (with new VID/PID)
  * FPGA bitstream v0.6.0, FX3 FW v2.0.0, libbladeRF v1.7.2, bladeRF-cli v1.4.0

 -- Jon Szymaniak <jon.szymaniak@nuand.com>  Wed, 29 Jun 2016 16:10:35 -0400

bladerf (2016.01-rc1) unstable; urgency=low

  * Added support for VCTCXO taming using 1.8V 1 PPS or 10 MHz input signal
  * Revised DC offset correction algorithm; fixes lockups
  * Added firmware logging mechanism
  * Updated firmware to FX3 SDK 1.3.3
  * Added libbladeRF support for setting SMB clock to arbitrary frequency
  * Added XB-100 host support
  * Fixed TX undderrun issues (now correctly uses all available buffers)


=== debian/control ===
Source: bladerf
Priority: optional
Maintainer: Nuand LLC <bladeRF@nuand.com>
Build-Depends: debhelper (>=9), cmake (>= 2.8.5), pkg-config, doxygen,
 libusb-1.0-0-dev (>= 1.0.12), libedit-dev, libncurses5-dev,
 git, help2man, pandoc, libcurl4-openssl-dev
Standards-Version: 4.1.4
Section: comm
Homepage: https://www.nuand.com/bladeRF
Vcs-Git: git://github.com/Nuand/bladeRF.git
Vcs-Browser: https://github.com/Nuand/bladeRF

Package: libbladerf2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libusb-1.0-0 (>= 1.0.12)
Recommends: bladerf-fpga, libbladerf-udev
Suggests: bladerf-firmware
Description: Nuand bladeRF software-defined radio device
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides the host library.

Package: libbladerf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbladerf2 (= ${binary:Version}), libc6-dev | libc-dev, ${misc:Depends}
Description: Nuand bladeRF software-defined radio device (header files)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains the header files required for compiling bladeRF
 applications.

Package: libbladerf-doc
Section: doc
Architecture: any
Depends: ${misc:Depends}
Description: Nuand bladeRF software-defined radio device (API documentation)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains libbladeRF API documentation.

Package: libbladerf-udev
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, udev
Conflicts: libbladerf0
Description: Nuand bladeRF software-defined radio device (header files)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains udev rules to ensure that the USB device is
 configured correctly when connected.

Package: bladerf
Section: comm
Architecture: any
Multi-Arch: foreign
Depends: libbladerf2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, libbladerf-udev
Provides: bladerf-host
Conflicts: bladerf-host
Replaces: bladerf-host
Description: Nuand bladeRF software-defined radio device (tools)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides command-line tools for controlling the bladeRF.

Package: bladerf-fpga-hostedx40
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedx40)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF x40 with the Altera Cyclone IV
 EP4CE40 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedx115
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedx115)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF x115 with the Altera Cyclone IV
 EP4CE115 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedxa4
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedxA4)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF 2.0 Micro xA4 with the Altera Cyclone V
 5CEBA4 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedxa5
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedxA5)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF 2.0 Micro xA5 with the Altera Cyclone V
 5CEBA5 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedxa9
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedxA9)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF 2.0 Micro xA9 with the Altera Cyclone V
 5CEBA9 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-firmware-fx3
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-fpga
Provides: bladerf-firmware
Description: Nuand bladeRF firmware downloader (FX3)
 This package will, at the time of installation, download an appropriate
 firmware image for using the Nuand bladeRF with a Cypress FX3 USB
 controller.  The image will be downloaded from https://nuand.com/fx3/
 and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream will work for either the Nuand bladeRF x40 or the x115,
 as well as the bladeRF 2.0 Micro xA4 or xA5 or xA9.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.
